///////////////////////////////////////////////////////////
// Softwarebauelemente I, Aufgabe O1.1
//
// author:			Stephan Brumme
// last changes:	January 13, 2001

#if !defined(AFX_ROOM_H__34138CE0_E97C_11D4_9BB7_8BA1BD2C3421__INCLUDED_)
#define AFX_ROOM_H__34138CE0_E97C_11D4_9BB7_8BA1BD2C3421__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// use the CEDL names for data types
#include "PrimitiveTypes.h"


// declare class CRoom
class CRoom  
{
private:
	// protect the member variables
	Ordinal m_nNumberOfRoom;
	Ordinal m_nArea;

public:
	// constructor (former Init !)
	CRoom(Ordinal nNumberOfRoom, Ordinal nArea) : 
		m_nArea(nArea), m_nNumberOfRoom(nNumberOfRoom) {}

	// destructor (not neccessary)
	virtual ~CRoom() {}

	// compare two rooms
	virtual Boolean operator==(const CRoom& room) const;
	virtual Boolean EqualValue(const CRoom& room) const;

	// copy one room to another one
    virtual CRoom&  operator=(const CRoom& room);
	virtual Boolean Copy     (const CRoom& room);
	
	// access m_nNumberOfRoom
	Ordinal GetNumberOfRoom() const;
	void    SetNumberOfRoom(const Ordinal nNumberOfRoom);
	
	// retrieve covered area
	Ordinal GetArea() const;

	// display the attributes
	// only for internal purposes !
	virtual void Show() const;
};

#endif // !defined(AFX_ROOM_H__34138CE0_E97C_11D4_9BB7_8BA1BD2C3421__INCLUDED_)
